with Lower_Layer_TCP;
with Lower_Layer.Inet.Misc;
with Ada.Command_Line;
with Ada.Text_IO;
with Ada.Characters.Latin_1;
with Ada.IO_Exceptions;
with Ada.Strings.Unbounded;
with Ada.Characters.Handling;


procedure cliente is

   package TCP renames Lower_Layer_TCP;
   package ASU renames Ada.Strings.Unbounded;
   package LLI renames Lower_Layer.Inet.Misc;
   package AIO renames Ada.Text_IO;
   package ACH renames Ada.Characters.Handling;

   Usage_Error: exception;

   Dir_IP, Dir_IP2  : TCP.End_Point;
   Serv_Conn, Serv_Conn2  : aliased TCP.Connection;
   Num: Integer;
   Content: Integer;
   Doc, Cab, Cabaux: ASU.Unbounded_String:=ASU.Null_Unbounded_String;
   Car: Character;
   TipoPet, Inicio, Maquina, Puerto, DirRel, Final: ASU.Unbounded_String;


   -- ************************************************************************************************
   -- *  A partir de un Unbounded que contiene una peticin de tipo get o put, la separa en varias   *
   -- *  partes, maquina, puerto, direccin relativa, ...                                            *
   -- ************************************************************************************************
   procedure Separar_URL (Peticion: ASU.Unbounded_String) is
      PeticionS: String(1..500);
      Tamano: Integer;
      Num, Num2: Integer;
   begin
      TipoPet:= ASU.Null_Unbounded_String;
      Inicio:= ASU.Null_Unbounded_String;
      Maquina:= ASU.Null_Unbounded_String;
      Puerto:= ASU.Null_Unbounded_String;
      DirRel:= ASU.Null_Unbounded_String;
      Final:= ASU.Null_Unbounded_String;

      Tamano:= ASU.To_String(Peticion)'Length;
      PeticionS(1..Tamano):= ASU.To_String(Peticion);

      -- Sacar el tipo de peticin, si es un GET o un PUT
      Num:= ASU.Index (Peticion, "GET");
      if Num>0 then
         Num2:= Num+4;
         TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
      else
         Num:=ASU.Index (Peticion, "PUT");
         if Num>0 then
            Num2:=Num+4;
            TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
         else
            AIO.Put_Line ("ERROR: No se ha encontrado ninguna peticin");
         end if;
      end if;

      -- Sacar lo que hay despus del GET o del PUT, pero antes del nombre de mquina, "siempre" http://
      Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), "http://");
      Inicio:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num+5));
      Num2:=Num2+Num+6;

      -- Sacar el nombre de la mquina
      Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), ":");
      if Num>0 then
         Maquina:=ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
         Num2:=Num2+Num;

         -- Saco el nmero de puerto
         Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano)),"/");
         if Num>0 then
            Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
            Num2:=Num2+Num-1;
         else
            Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano))," ");
            Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
            Num2:= Num2+Num;
         end if;
      else
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)),"/");
         Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
         Num2:=Num2+Num-1;
         Puerto:= ASU.To_Unbounded_String ("80");
      end if;

      -- Sacar la direccin relativa

      if (PeticionS(Num2)='/') then
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
         DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
         Num2:=Num2+Num-1;
      else
         DirRel:= ASU.To_Unbounded_String("/");
      end if;

      -- Sacar el final de la peticin, es decir el HTTP/1.0 o HTTP/1.1
      Final:= ASU.To_Unbounded_String (PeticionS(Num2..Tamano-2));

      AIO.Put_Line ("TipoPet: " & ASU.To_String(Tipopet) & ASU.To_String(Tipopet));
      AIO.Put_Line ("Inicio:  " & ASU.To_String(Inicio) & ASU.To_String(Inicio));
      AIO.Put_Line ("Maquina: " & ASU.To_String(maquina) & ASU.To_String(Maquina));
      AIO.Put_Line ("Puerto:  " & ASU.To_String(puerto) & ASU.To_String(Puerto));
      AIO.Put_Line ("Dirrel:  " & ASU.To_String(dirrel) & ASU.To_String(Dirrel));
      AIO.Put_Line ("Final:   " & ASU.To_String(final) & ASU.To_String(Final));




   end Separar_URL;


   -- *******************************************************************************************
   -- *                   Mando una peticin a travs de Serv_Conn2                             *
   -- *******************************************************************************************
   procedure Mando_Peticion is
   begin
      String'Write (Serv_Conn2'Access, ASU.To_String(TipoPet));
      -- String'Write (Serv_Conn2'Access, ASU.To_String(Inicio));
      -- String'Write (Serv_Conn2'Access, ASU.To_String(Maquina));
      -- String'Write (Serv_Conn2'Access, ":");
      -- String'Write (Serv_Conn2'Access, ASU.To_String(Puerto));
      String'Write (Serv_Conn2'Access, ASU.To_String(DirRel));
      String'Write (Serv_Conn2'Access, ASU.To_String(Final));
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.LF);
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.LF);
   end Mando_Peticion;


   -- *********************************************************************************************
   -- *                 Extraigo una cabecera de Serv_Conn2                                       *
   -- *********************************************************************************************
   function Extraer_Cabecera return ASU.Unbounded_String is
      Done, Almost_Done: Boolean:= False;
      Cabecera: ASU.Unbounded_String:= ASU.Null_Unbounded_String;
      Car: Character;
   begin
      Done:= False;
      while not Done loop
         Character'Read (Serv_Conn2'Access, Car);
         Cabecera:= ASU.To_Unbounded_String (ASU.To_String(Cabecera) & Car);
         case Car is
            when Ada.Characters.Latin_1.LF =>
               if Almost_Done then
                  Done := True;
               else
                  Almost_Done := True;
               end if;
            when Ada.Characters.Latin_1.CR =>
               Almost_Done:= Almost_Done;
            when others =>
               Almost_Done := False;
         end case;
      end loop;
      return (Cabecera);
   end Extraer_Cabecera;


   -- *********************************************************************************************
   -- *     Devuelvo el valor de content length de la cabecera. Si no existe devuelvo 0           *
   -- *********************************************************************************************
   function Sacar_Content_Length (Cabecer: ASU.Unbounded_String) return Integer is
      Ultimo, I, Num, Resul: Integer;
      CabecerS: String (1..10000);

   begin
      Ultimo:= ASU.To_String(Cabecer)'Length;
      CabecerS(1..Ultimo):= ASU.To_String(Cabecer);
      Num:= ASU.Index (ASU.To_Unbounded_String(ACH.To_Lower (CabecerS(1..Ultimo))), "content-length:");
      if Num>0 then
         I:= Num+16;
         while (CabecerS(I)/=Ada.Characters.Latin_1.CR) loop
            I:=I+1;
         end loop;
         Resul:= Integer'Value (CabecerS(Num+16..I-1));
      else
         Resul:= 0;
      end if;
      return (Resul);
   end Sacar_Content_Length;



   -- *************************************************************************************************
   -- *                                   PROGRAMA PRINCIPAL                                          *
   -- *************************************************************************************************

begin
   if Ada.Command_Line.Argument_Count /= 3 then
      raise Usage_Error;
   end if;

   AIO.Put_Line ("Voy a separar la URL");
   Separar_URL (ASU.To_Unbounded_String("GET " & Ada.Command_Line.Argument(1) & " HTTP/1.0  "));
   AIO.Put_Line ("He separado URL, voy a conectarme ...");
   Dir_IP2:= TCP.Build (LLI.To_IP(ASU.To_String(Maquina)), Integer'Value(ASU.To_String(Puerto)));
   TCP.Connect (Dir_IP2, Serv_Conn2);
   AIO.Put_Line ("Me he conectado, mandando peticin al servidor ....");
   Mando_Peticion;

   AIO.Put_Line ("Extraigo la cabecera ....");
   Cab:= Extraer_Cabecera;
   Content:= Sacar_Content_Length(Cab);
   AIO.Put_Line ("EL Content-length es: " & INteger'Image(Content));
   AIO.Put_Line ("Recibiendo el documento...");
   Cabaux:= ASU.To_Unbounded_String ("PUT " & "http://" & Ada.Command_Line.Argument(2) & ":" & Ada.Command_Line.Argument(3) & "/feed" & " HTTP/1.0" & Ada.Characters.Latin_1.CR & Ada.Characters.Latin_1.LF);
   if Content>0 then
      for I in 1..Content loop
         Character'Read (Serv_Conn2'Access, Car);
         Doc:=ASU.To_Unbounded_String (ASU.To_String(Doc) & Car);
      end loop;
   else
      AIO.Put_Line ("Pagina sin content length");

      Content:=0;
      begin
         loop
            Character'Read (Serv_Conn2'Access, Car);
            Doc:= ASU.To_Unbounded_String (ASU.To_String(Doc) & Car);
            Content:= Content+1;
         end loop;
      exception
         when Ada.IO_Exceptions.End_Error =>
            TCP.Dispose (Serv_Conn2);
            Ada.Text_IO.Put ("EXC: Conexin cerrada por el otro servidor (Por no tener content)");
            Cabaux:= ASU.To_Unbounded_String( ASU.To_String(Cabaux) & "content-length:" & Integer'Image(Content) & Ada.Characters.Latin_1.CR & Ada.Characters.Latin_1.LF);
         when Usage_Error =>
            Ada.Text_IO.Put_Line ("Two arguments needed: host_no and port");
            --when others =>
            --   AIO.Put_Line ("parte others de la excepcin");
         when The_Error : others =>
            AIO.Put_Line("Unknown error:");
      end;

   end if;
   AIO.Put_Line ("Termino de recibir el documento");
   TCP.Dispose (Serv_Conn2);

   Dir_IP := TCP.Build (Ada.Command_Line.Argument (2),
                         Integer'Value (Ada.Command_Line.Argument (3)));
   TCP.Connect (Dir_IP, Serv_Conn);
   AIO.Put_Line ("Cierro la conexin con el servidor");


   Cab:= ASU.To_Unbounded_String (ASU.To_String(Cabaux) & ASU.To_String(Cab));

   AIO.Put_Line ("Mando Cabecera");
   String'Write (Serv_Conn'Access, ASU.To_String(Cab));


   AIO.Put_Line ("Mando el documento");
   String'Write (Serv_Conn'Access, ASU.To_String(Doc));

   AIO.Put_Line ("Esperando confirmacin... ");
   Cab:= Extraer_Cabecera;

   Num:= ASU.Index (Cab, "201");
   if Num>0 then
      AIO.Put_Line ("Operacin realizada con XITO");
   else
      AIO.Put_Line ("Ha ocurrido algn ERROR al realizar la operacin");
   end if;
   TCP.Dispose (Serv_Conn);
   AIO.Put_Line ("Cierro la conexin con el servidor");


exception
   when Ada.IO_Exceptions.End_Error =>
      TCP.Dispose (Serv_Conn);
      Ada.Text_IO.Put ("Connection closed by server");
      Ada.Text_IO.New_Line;
   when Usage_Error =>
      Ada.Text_IO.Put_Line ("Two arguments needed: host_no and port");
   when others =>
      AIO.Put_Line ("Conexin cerrada por mi servidor");

end Cliente;
