with Lower_Layer_TCP;
with Lower_Layer.Inet.Misc;
with Ada.Command_Line;
with Ada.Text_IO;
with Ada.Characters.Latin_1;
with Ada.IO_Exceptions;
with Ada.Strings.Unbounded;
with Ada.Characters.Handling;


procedure cliente_stat is

   package TCP renames Lower_Layer_TCP;
   package ASU renames Ada.Strings.Unbounded;
   package LLI renames Lower_Layer.Inet.Misc;
   package AIO renames Ada.Text_IO;
   package ACH renames Ada.Characters.Handling;

   Usage_Error: exception;

   Dir_IP : TCP.End_Point;
   Serv_Conn : aliased TCP.Connection;

   Done, Almost_Done: Boolean;

   Car: Character;

begin
   if Ada.Command_Line.Argument_Count /= 2 then
      raise Usage_Error;
   end if;


   Dir_IP := TCP.Build (Ada.Command_Line.Argument (1),
                         Integer'Value (Ada.Command_Line.Argument (2)));
   TCP.Connect (Dir_IP, Serv_Conn);



   -- Le mando la peticin
   String'Write (Serv_Conn'Access, "GET http://");
   String'Write (Serv_Conn'Access, Ada.Command_Line.Argument(1));
   String'Write (Serv_Conn'Access, ":");
   String'Write (Serv_Conn'Access, Ada.Command_Line.Argument(2));
   String'Write (Serv_Conn'Access, "/stats HTTP/1.0");
   Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
   Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
   Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
   Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);

   AIO.Put_Line ("Mando Peticin...");
   AIO.Put_Line ("Esperando estadstica... ");
   Almost_Done:= False;
   Done:= False;
   while not Done loop
      Character'Read (Serv_Conn'Access, Car);
      AIO.Put (Car);
      case Car is
         when Ada.Characters.Latin_1.LF =>
            if Almost_Done then
               Done := True;
            else
               Almost_Done := True;
            end if;
         when Ada.Characters.Latin_1.CR =>
            Almost_Done:= Almost_Done;
         when others =>
            Almost_Done := False;
      end case;
   end loop;



   TCP.Dispose (Serv_Conn);
   AIO.Put_Line ("Cierro la conexin con el servidor");


exception
   when Ada.IO_Exceptions.End_Error =>
      TCP.Dispose (Serv_Conn);
      Ada.Text_IO.Put ("Connection closed by server");
      Ada.Text_IO.New_Line;
   when Usage_Error =>
      Ada.Text_IO.Put_Line ("Two arguments needed: host_no and port");
   when others =>
      AIO.Put_Line ("Conexin cerrada por mi servidor");

end Cliente_stat;
