with Ada.Strings.Unbounded;
with Ada.Text_IO;




package body paqtabla is

   function Buscar_Documento (Tab: in Tipo_Tabla; Nom: in ASU.Unbounded_String) return Integer is
      Encontrado: Boolean:=False;
      I, resul: Integer:=1;

   begin

      while (I<=Tamano_Tabla) and (not Encontrado) loop
         if ASU.To_String(Tab(I).Nombre)=ASU.To_String(Nom) then
            Encontrado:=True;
         else
            I:=I+1;
         end if;
      end loop;
      if (Encontrado) then
         Resul:=I;
      else
         Resul:=0;
      end if;
      return (Resul);
   end Buscar_Documento;


   procedure Insertar_Documento (Tab: in out Tipo_Tabla; Nom: in ASU.Unbounded_String; Doc: in ASU.Unbounded_String; Indice: in out Integer) is
      I: Integer;
   begin
      I:= Buscar_Documento (Tab, Nom);
      Ada.Text_IO.Put_line ("EN insertar, encuentro documento en " & Integer'Image(I));
      if (I/=0) then
         Tab(I).Docu:=Doc;
      else
         if Indice<=Tamano_Tabla then
            Tab(Indice).Docu:= Doc;
            Tab(Indice).Nombre:=Nom;
            Indice:=Indice+1;
         else
            Tab(1).Docu:= Doc;
            Tab(1).Nombre:=Nom;
            Indice:=2;
         end if;
      end if;
   end Insertar_Documento;

   procedure Recuperar_Documento (Tab: in Tipo_Tabla; Nom: in ASU.Unbounded_String; Doc: out ASU.Unbounded_String) is
      I: Integer;
   begin
      I:= Buscar_Documento (Tab, Nom);
      if (I/=0) then
         Doc:= Tab(I).docu;
      else
         Doc:= ASU.Null_Unbounded_String;
      end if;
   End Recuperar_Documento;

   procedure Recuperar_DocNum (Tab: in Tipo_Tabla; Nom: out ASU.Unbounded_String; Doc: out ASU.Unbounded_String; Num: in Natural) is
   begin
      Doc:= Tab(Num).Docu;
      Nom:= Tab(Num).Nombre;
   end;
   procedure Borrar_Documento (Tab: in out Tipo_Tabla; Nom: in ASU.Unbounded_String) is
      I: Integer:=1;
   begin
      I:= Buscar_Documento (Tab, Nom);
      if (I/=0) then
         Tab(I).Docu:= ASU.Null_Unbounded_String;
         Tab(I).Nombre:= ASU.Null_Unbounded_String;
      end if;
   end Borrar_Documento;

   procedure Visualizar_Tabla (Tab: in Tipo_Tabla; Ind: in Integer) is
   begin
      Ada.Text_IO.Put_Line ("***** TABLA CACHE (indice: " & Integer'Image(Ind) & ") ******");
      for I in 1..Tamano_Tabla loop
         Ada.Text_IO.Put_Line (Integer'Image(I) & ASU.To_String(Tab(I).Nombre));
      end loop;
   end Visualizar_Tabla;
end paqtabla;







