
with Lower_Layer_TCP;
with Lower_Layer.Inet.Misc;
with Ada.Command_Line;
with Ada.Text_IO;
with Ada.Characters.Latin_1;
with Ada.IO_Exceptions;
with Ada.Exceptions;
with Ada.Strings.Unbounded;
with Ada.Strings.Maps;
with Ada.Characters.Handling;

with paqtabla;



procedure servidor is

   package ACH renames Ada.Characters.Handling;
   package TCP renames Lower_Layer_TCP;
   package ASU renames Ada.Strings.Unbounded;
   package AIO renames Ada.Text_IO;
   package LLI renames Lower_Layer.Inet.Misc;
   Usage_Error: exception;

   Dir_IP: TCP.End_Point;
   Serv_Conn: aliased TCP.Connection;
   Pet: ASU.Unbounded_String;
   Serv_Conn2: aliased TCP.Connection;

   -- Para separar la URL
   Tipopet, Inicio, Maquina, Puerto, Dirrel, Final: ASU.Unbounded_String;

   -- Tabla para la cach
   Tabla: Paqtabla.Tipo_Tabla;
   Indice: Integer:=1;

   -- Para las estadsticas
   Num_Get, Num_Put: Natural := 0;
   Byt_Get, Byt_Put_Recibo, Byt_Put_Pido: Natural:= 0;
   Tabla_Llena: Boolean := False;



   -- ************************************************************************************************
   -- Parte de un Unbounded, que contiene una peticin de tipo put, o get, y lo separa en partes:    *
   -- El tipo de peticin, el nombre de mquina, el puerto, la direccin relativa y lo que va detrs *
   -- ************************************************************************************************
   procedure Separar_URL (Peticion: ASU.Unbounded_String) is
      PeticionS: String(1..500);
      Tamano: Integer;
      Num, Num2, Num3: Integer;
   begin
      TipoPet:= ASU.Null_Unbounded_String;
      Inicio:= ASU.Null_Unbounded_String;
      Maquina:= ASU.Null_Unbounded_String;
      Puerto:= ASU.Null_Unbounded_String;
      DirRel:= ASU.Null_Unbounded_String;
      Final:= ASU.Null_Unbounded_String;

      Tamano:= ASU.To_String(Peticion)'Length;
      PeticionS(1..Tamano):= ASU.To_String(Peticion);
      AIO.Put_Line ("La PETICIN A SEPARAR es: " & ASU.To_String(Peticion));

      -- Sacar el tipo de peticin, si es un GET o un PUT
      Num:= ASU.Index (Peticion, "GET");
      if Num>0 then
         Num2:= Num+4;
         TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
      else
         Num:=ASU.Index (Peticion, "PUT");
         if Num>0 then
            Num2:=Num+4;
            TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
         else
            AIO.Put_Line ("ERROR: No se ha encontrado ninguna peticin");
         end if;
      end if;

      -- Sacar lo que hay despus del GET o del PUT, pero antes del nombre de mquina, "siempre" http://
      Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), "http://");
      Inicio:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num+5));
      Num2:=Num2+Num+6;

      -- Sacar el nombre de la mquina
      Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), ":");
      if Num>0 then
         Maquina:=ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
         Num2:=Num2+Num;

         -- Saco el nmero de puerto
         Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano)),"/");
         if Num>0 then
            Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
            Num2:=Num2+Num-1;
         else
            Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano))," ");
            Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
            Num2:= Num2+Num;
         end if;
         if (PeticionS(Num2)='/') then
            Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
            DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
            Num2:=Num2+Num-1;
         else
            DirRel:= ASU.To_Unbounded_String("/");
         end if;
      else
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)),"/");
         Num3:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-1))," ");
         if (Num>0 and Num3=0)then
            Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
            Num2:=Num2+Num-1;
            Puerto:= ASU.To_Unbounded_String ("80");
            if (PeticionS(Num2)='/') then
               Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
               DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
            else
               DirRel:= ASU.To_Unbounded_String("/");
            end if;
         else
            Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
            Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
            Puerto:= ASU.To_Unbounded_String ("80");
            DirRel:= ASU.To_Unbounded_String("/");
            Num2:=Num2+Num-1;
         end if;
      end if;

      Final:= ASU.To_Unbounded_String (PeticionS(Num2..Tamano-2));

      -- AIO.Put_Line ("TipoPet: " & ASU.To_String(Tipopet) & ASU.To_String(Tipopet));
      -- AIO.Put_Line ("Inicio:  " & ASU.To_String(Inicio) & ASU.To_String(Inicio));
      -- AIO.Put_Line ("Maquina: " & ASU.To_String(maquina) & ASU.To_String(Maquina));
      -- AIO.Put_Line ("Puerto:  " & ASU.To_String(puerto) & ASU.To_String(Puerto));
      -- AIO.Put_Line ("Dirrel:  " & ASU.To_String(dirrel) & ASU.To_String(Dirrel));
      -- AIO.Put_Line ("Final:   " & ASU.To_String(final) & ASU.To_String(Final));
   end Separar_URL;


   -- ***************************************************************************************
   -- *        Esta funcin lee de Serv_Conn, una peticin hasta que le llegan dos LF       *
   -- ***************************************************************************************
   function Extraer_Peticion return ASU.Unbounded_String is
      Done, Almost_Done, Comando_Leido: Boolean := False;
      Peticion: ASU.Unbounded_String:= ASU.Null_Unbounded_String;
      A_Char: Character;
   begin
      Done := False;
      while not Done loop
         Character'Read (Serv_Conn'Access, A_Char);
         Peticion:= ASU.To_Unbounded_String (ASU.To_String(Peticion) & A_Char);
         case A_Char is
            when Ada.Characters.Latin_1.LF =>
               if (not Comando_Leido) then
                  Comando_Leido:=True;
                  Separar_URL (Peticion);
               end if;

               if Almost_Done then
                  Done := True;
               else
                  Almost_Done := True;
               end if;
            when Ada.Characters.Latin_1.CR =>
               Almost_Done:= Almost_Done;
            when others =>
               Almost_Done := False;
         end case;
      end loop;
      return (Peticion);
   end Extraer_Peticion;



   -- *******************************************************************************
   -- *    Esta funcin lee la cabecera que le mandan por Serv_Conn2 hasta que le   *
   -- *    llegan dos CR o dos LF, ya que hay alguna cabecera que no tiene CR       *
   -- *******************************************************************************
   function Extraer_Cabecera return ASU.Unbounded_String is
      Done, Almost_Done: Boolean:= False;
      Cabecera: ASU.Unbounded_String:= ASU.Null_Unbounded_String;
      Car: Character;
   begin
      Done:= False;
      while not Done loop
         Character'Read (Serv_Conn2'Access, Car);
         Cabecera:= ASU.To_Unbounded_String (ASU.To_String(Cabecera) & Car);
         case Car is
            when Ada.Characters.Latin_1.LF =>
               if Almost_Done then
                  Done := True;
               else
                  Almost_Done := True;
               end if;
            when Ada.Characters.Latin_1.CR =>
               if Almost_Done then
                  Done:= True;
               else
                  Almost_Done:= True;
               end if;
            when others =>
               Almost_Done := False;
         end case;
      end loop;
      return (Cabecera);
   end Extraer_Cabecera;


   -- ***********************************************************************************
   -- *            No hago de proxy y mando una pgina propia                           *
   -- ***********************************************************************************
   procedure Mandar_Mi_Pagina is
      Dummy_Reply: String :=
        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
        Ada.Characters.Latin_1.LF &
        "<HTML><HEAD>" &
        Ada.Characters.Latin_1.LF &
        "<TITLE>CojoServer 0.0</TITLE>" &
        Ada.Characters.Latin_1.LF &
        "</HEAD><BODY>" &
        Ada.Characters.Latin_1.LF &
        "<H1>CojoServer 0.0</H1>" &
        Ada.Characters.Latin_1.LF &
        "Your request was received and completely ignored!!!" &
        Ada.Characters.Latin_1.LF &
        "</BODY></HTML>";

   begin
      String'Write (Serv_Conn'Access, Dummy_Reply);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
      TCP.Dispose (Serv_Conn);
      Ada.Text_IO.Put_Line ("Conexin cerrada por mi");
   end Mandar_Mi_Pagina;


   -- *******************************************************************************************
   -- *   Esta funcin coge una cabecera, y busca el content length, devuelve el valor de ste  *
   -- *   si existe, y si no devuelve 0                                                         *
   -- *******************************************************************************************
   function Sacar_Content_Length (Cabecer: ASU.Unbounded_String) return Integer is
      Ultimo, I, Num, Resul: Integer;
      CabecerS: String (1..10000);

   begin
      Ultimo:= ASU.To_String(Cabecer)'Length;
      CabecerS(1..Ultimo):= ASU.To_String(Cabecer);
      Num:= ASU.Index (ASU.To_Unbounded_String(ACH.To_Lower (CabecerS(1..Ultimo))), "content-length:");
      if Num>0 then
         I:= Num+16;
         while (CabecerS(I)/=Ada.Characters.Latin_1.CR) and (CabecerS(I)/=Ada.Characters.Latin_1.LF) loop
            I:=I+1;
         end loop;
         Resul:= Integer'Value (CabecerS(Num+16..I-1));
      else
         Resul:= 0;
      end if;
      return (Resul);
   end Sacar_Content_Length;


   -- *********************************************************************************************
   -- *             Mando la peticin a travs de Serv_Conn2                                      *
   -- *********************************************************************************************
   procedure Mando_Peticion is
   begin
      String'Write (Serv_Conn2'Access, ASU.To_String(TipoPet));
      -- String'Write (Serv_Conn2'Access, ASU.To_String(Inicio));
      -- String'Write (Serv_Conn2'Access, ASU.To_String(Maquina));
      -- String'Write (Serv_Conn2'Access, ":");
      -- String'Write (Serv_Conn2'Access, ASU.To_String(Puerto));
      String'Write (Serv_Conn2'Access, ASU.To_String(DirRel));
      String'Write (Serv_Conn2'Access, ASU.To_String(Final));
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.LF);
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn2'Access,  Ada.Characters.Latin_1.LF);
   end Mando_Peticion;


   -- ********************************************************************************************
   -- *   En esta funcin se realizan las funciones del proxy. Cuando se recibe una peticin     *
   -- *   me conecto con el servidor que contiene la pgina, me la manda y yo se la mando al     *
   -- *   cliente                                                                                *
   -- ********************************************************************************************
   procedure Hacer_De_Proxy is
      Dir_IP2: TCP.End_Point;
      Content: Natural;
      Cabec: ASU.Unbounded_String;
      ExisteIP: Boolean;
      Direccionip: ASU.Unbounded_String;

      Car: Character;
      Nom, Doc: ASU.Unbounded_String:=ASU.Null_Unbounded_String;
   begin
      begin
         ExisteIP:= True;
         -- Convierto el nombre de mquina en direccin IP y compruebo si hay algn error en esta operacin
         Direccionip:= ASU.To_Unbounded_String(LLI.To_IP ((ASU.To_String(Maquina))));
      exception
         when Ide:others =>
            begin
               AIO.Put_Line ("ERROR " & Ada.Exceptions.Exception_Name(Ide));
               ExisteIP:=False;
               AIO.Put_Line ("DIRECCIN IP NO EXISTE");
            end;
      end;

      if ExisteIP then
         -- Me conecto con el servidor para pedirle la pgina
         Dir_IP2:= TCP.Build (ASU.To_String(Direccionip), Integer'Value (ASU.To_String(Puerto)));
         TCP.Connect (Dir_IP2, Serv_Conn2);
         begin

            Nom:= ASU.To_Unbounded_String (ASU.To_String(Maquina) & ":" & ASU.To_String (Puerto) & ASU.To_String(DirRel));
            -- Si el documento est en la cach lo saco de ella y se lo envo al cliente
            if (PaqTabla.Buscar_Documento (Tabla, Nom)>0) then
               AIO.Put_Line ("Documento en CACH, lo saco y lo envo al cliente ....");
               Paqtabla.Recuperar_Documento (Tabla, Nom, Doc);
               String'Write (Serv_Conn'Access, ASU.To_String (Doc));
               TCP.Dispose (Serv_Conn);
               AIO.Put_Line ("Cierro Conexin con el cliente");
            else
               -- Si no est en la cach, se lo pido al servidor
               AIO.Put_Line ("Mandando peticin: " & ASU.To_String(TipoPet) & ASU.To_String(Inicio) & ASU.To_String(Maquina) & ":" &ASU.To_String(Puerto) & ASU.To_String(DirRel) & ASU.To_String(Final));
               Mando_Peticion;
               AIO.Put_Line ("Recibiendo cabecera .... ");
               Cabec:= Extraer_Cabecera;
               Byt_Get:= Byt_Get + ASU.To_String(Cabec)'Length;
               Doc:= Cabec;
               Content:= Sacar_Content_Length (Cabec);
               AIO.Put_Line ("El content-length es: " & Integer'Image(Content));
               String'Write (Serv_Conn'Access, ASU.To_String(Cabec));
               if Content>0 then
                  AIO.Put_Line ("PGINA QUE TIENE CONTENT-LENGTH, recibiendo y enviando al cliente ...");
                  for I in 1..Content loop
                     Character'Read (Serv_Conn2'Access, Car);
                     Byt_Get:= Byt_Get+1;
                     Doc:= ASU.To_Unbounded_String (ASU.To_String(Doc) & Car);
                     --AIO.Put(Car);
                     Character'Write (Serv_Conn'Access, Car);
                  end loop;
                  AIO.Put_Line ("Cierro Conexin con servidor");
                  AIO.Put_Line ("Cierro la conexin con el cliente");
                  Nom:= ASU.To_Unbounded_String (ASU.To_String(Maquina) & ":" & ASU.To_String (Puerto) & ASU.To_String(DirRel));
                  Paqtabla.Insertar_Documento (Tabla, Nom, Doc, Indice);
                  if Indice=PaqTabla.Tamano_Tabla then
                     Tabla_Llena:=True;
                  end if;
                  TCP.Dispose (Serv_Conn2);
                  TCP.Dispose (Serv_Conn);
               else
                  AIO.Put_Line ("PAGINA SIN CONTENT-LENGTH, recibiendo y enviando al cliente ...");

                  loop
                     Character'Read (Serv_Conn2'Access, Car);
                     Byt_Get:= Byt_Get+1;
                     Doc:= ASU.To_Unbounded_String (ASU.To_String(Doc) & Car);
                     Character'Write (Serv_Conn'Access, Car);
                  end loop;
                  TCP.Dispose (Serv_Conn2);



               end if;
            end if;
         end;
      end if;
   exception
      when Ada.IO_Exceptions.End_Error =>
         TCP.Dispose (Serv_Conn2);
         Ada.Text_IO.Put_Line ("EXC: Conexin cerrada por el otro servidor (No tiene content length)");
         Ada.Text_IO.New_Line;
         TCP.Dispose (Serv_Conn);
         PaqTabla.Insertar_Documento (Tabla, Nom, Doc, Indice);
         if Indice=PaqTabla.Tamano_Tabla then
            Tabla_Llena:=True;
         end if;
      when Usage_Error =>
         Ada.Text_IO.Put_Line ("Two arguments needed: host_no and port");
         --when others =>
         --   AIO.Put_Line ("parte others de la excepcin");
      when The_Error : others =>
         AIO.Put_Line("Unknown error:");
         AIO.Put_Line(Ada.Exceptions.Exception_Information(The_Error));
         AIO.Put_Line(Ada.Exceptions.Exception_Name(The_Error));
         AIO.Put_Line(Ada.Exceptions.Exception_Message(The_Error));

   end Hacer_De_Proxy;


   -- ***********************************************************************************************
   -- *  Cuando me hacen un put me mandan una pgina, en esta funcin se busca en esa pgina todos  *
   -- *  los enlaces que hayan, se obtienen esas pginas y se guardan en la cach                   *
   -- ***********************************************************************************************
   procedure Buscar_Y_Pedir_URL (Docum: ASU.Unbounded_String) is
      DocumS: String (1..1000000);
      Tam, Content, I, J, ant: Integer;
      Cabec, Nom: ASU.Unbounded_String;
      Dir_IP2: TCP.End_Point;
      Direccionip: ASU.Unbounded_String;
      Encontrado, existeip: Boolean;
      Car: Character;
   begin
      Tam:= ASU.To_String(Docum)'Length;

      DocumS(1..Tam):= ASU.To_String(Docum);

      ant:=1;
      Encontrado:=True;
      while (Encontrado)loop
         -- Busco el texto http:// en la pgina
         I:= ASU.Index (ASU.To_Unbounded_String(DocumS(ant..Tam)),"http://");
         if I>0 then
            J:=I+7;
            while DocumS(Ant+J-1)/='>' and (DocumS(ANt+J-1)/=' ') and DocumS(Ant+J-1)/=''' and DocumS(Ant+J-1)/='"' loop --"
               J:=J+1;
            end loop;
            Separar_URL (ASU.To_Unbounded_String("GET " & DocumS(Ant+I-1..Ant+J-2) & " HTTP/1.0  "));
            Ant:=Ant+J-1;
            begin
               ExisteIP:= True;
               Direccionip:= ASU.To_Unbounded_String(LLI.To_IP ((ASU.To_String(Maquina))));
            exception
               when Ide:others =>
                  begin
                     AIO.Put_Line ("ERROR " & Ada.Exceptions.Exception_Name(Ide));
                     ExisteIP:=False;
                     AIO.Put_Line ("DIRECCIN IP NO EXISTE");
                  end;
            end;

            if ExisteIP then

               Dir_IP2:= TCP.Build (ASU.To_String(Direccionip), Integer'Value (ASU.To_String(Puerto)));
               TCP.Connect (Dir_IP2, Serv_Conn2);
               AIO.Put_LIne ("***************** NUEVA URL ENCONTRADA *********************");
               AIO.Put_Line ("MANDANDO Peticin para buscar pgina: " & ASU.To_String(Maquina) & ":" & ASU.To_String(Puerto) & ASU.To_String(DirRel) & " ...");
               Mando_Peticion;
               AIO.Put_Line ("Esperando la cabecera ...");
               Cabec:= Extraer_Cabecera;
               Byt_Put_Pido:= Byt_Put_Pido + ASU.To_String(Cabec)'Length;
               AIO.Put_Line ("Voy a sacar el content-length de la cabecera");
               Content:= Sacar_Content_Length (Cabec);
               AIO.Put_Line ("Saco content-length: " & Integer'Image(Content) & ", y recibo pgina .... ");
               if Content>0 then
                  for J in 1..Content loop
                     Character'Read (Serv_Conn2'Access, Car);
                     Byt_Put_Pido:= Byt_Put_Pido +1;
                     Cabec:= ASU.To_Unbounded_String (ASU.To_String(Cabec) & Car);
                  end loop;
               else
                  begin
                     loop
                        Character'Read (Serv_Conn2'Access, Car);
                        Byt_Put_Pido:= Byt_Put_Pido +1;
                        Cabec:= ASU.To_Unbounded_String (ASU.To_String(Cabec) & Car);
                     end loop;


                  exception
                     when Ada.IO_Exceptions.End_Error =>
                        TCP.Dispose (Serv_Conn2);
                        Ada.Text_IO.Put_Line ("EXC: Conexin cerrada por el otro servidor (por content-length)");
                     when Usage_Error =>
                        Ada.Text_IO.Put_Line ("Two arguments needed: host_no and port");
                     when others =>
                        AIO.Put_Line("Unknown error:");
                  end;
               end if;

               Nom:= ASU.To_Unbounded_String (ASU.To_String(Maquina) & ":" & ASU.To_String(Puerto) & ASU.To_String(DirRel));
               Paqtabla.Insertar_Documento (Tabla, Nom, Cabec, Indice);
               if Indice=PaqTabla.Tamano_Tabla then
                  Tabla_Llena:=True;
               end if;
               AIO.Put_Line ("PAGINA GUARDADA EN LA CACHE");
               PaqTabla.Visualizar_Tabla(Tabla, Indice);
               TCP.Dispose (Serv_Conn2);
               AIO.Put_Line ("Cierro Conexin con el servidor");
            else
               AIO.Put_Line ("LA DIRECCIN IP NO EXISTE");
            end if;
         else
            Encontrado:=False;
         end if;
      end loop;

   end Buscar_Y_Pedir_URL;


   -- **************************************************************************************************
   -- *   Se le manda una confirmacin al cliente para indicarle que el put se ha realizado con xito  *
   -- **************************************************************************************************
   procedure Mandar_Confirmacion_Cliente is
   begin
      String'Write (Serv_Conn'Access, "HTTP/1.1 201 OK");
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
      Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
      TCP.Dispose (Serv_Conn);
      AIO.Put_Line ("Cierro Conexin con el cliente");
   end Mandar_Confirmacion_Cliente;

   procedure Hacer_Put is
      Content: Integer;
      Doc: ASU.Unbounded_String;
      Car: Character;
   begin
      AIO.Put_Line ("Peticin PUT");
      Content:= Sacar_Content_Length (Pet);
      if ASU.To_String(DirRel)/="/feed" and ASU.To_String(DirRel)/="/feed/" then
         String'Write (Serv_Conn'Access, "HTTP/1.1 404 Not Found");
         Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
         Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
         Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.CR);
         Character'Write (Serv_Conn'Access,  Ada.Characters.Latin_1.LF);
         TCP.Dispose (Serv_Conn);
         AIO.Put_Line ("Cierro Conexin con el cliente, porque no corresponde a *** /feed *** ");
      else
          if Content>0 then
             for I in 1..Content loop
                Character'Read (Serv_Conn'Access, Car);
                Byt_Put_Recibo:= Byt_Put_Recibo +1;
                Doc:= ASU.To_Unbounded_String(ASU.To_String(Doc) & Car);
             end loop;
             Buscar_Y_Pedir_URL (Doc);
             Mandar_Confirmacion_Cliente;

          else
             AIO.Put_Line ("ERROR: NO SE ENCUENTRA EL CONTENT LENGTH");
          end if;
      end if;

   end Hacer_Put;


   -- ****************************************************************************************************
   -- *              Mando la estadstica de los accesos al servidor                                     *
   -- ****************************************************************************************************
   procedure Mandar_Estadistica is
      N, D: ASU.Unbounded_String;
   begin
      String'Write (Serv_Conn'Access, "<html>");
      String'Write (Serv_Conn'Access, "<BR>");
      Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);
      String'Write (Serv_Conn'Access, "ESTADSTICAS DEL SERVIDOR");
      String'Write (Serv_Conn'Access, "<BR>");
      Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);
      String'Write (Serv_Conn'Access, "Accesos totales: " & Integer'Image(Num_Put+Num_Get));
      String'Write (Serv_Conn'Access, "<BR>");
      Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);
      String'Write (Serv_Conn'Access, "Nmero de GET: " & Integer'Image(Num_Get) & " (" & Integer'Image(Byt_Get) & " bytes)");
      String'Write (Serv_Conn'Access, "<BR>");
      Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);
      String'Write (Serv_Conn'Access, "Nmero de PUT: " & Integer'Image(Num_Put) & " (" & Integer'Image(Byt_Put_Recibo) & " bytes, " & Integer'Image(Byt_Put_Pido) & " bytes pedidos)");
      String'Write (Serv_Conn'Access, "<BR>");
      Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);

      for I in 1..Paqtabla.Tamano_Tabla loop
         PaqTabla.Recuperar_DocNum (Tabla, N, D, I);
         String'Write (Serv_Conn'Access, Integer'Image(I) & ": " & ASU.To_String(N) & " (" & Integer'Image(ASU.To_String(D)'Length) & " )");
         String'Write (Serv_Conn'Access, "<BR>");
         Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);
      end loop;
      if not (Tabla_Llena) then
         String'Write (Serv_Conn'Access, "Documentos en la tabla: " & Integer'Image(Indice-1));
      else
         if ASU.To_String(D)="" then
            String'Write (Serv_Conn'Access, "Documentos en la tabla: " & Integer'Image(PaqTabla.Tamano_Tabla-1) & " (llena)");
         else
            String'Write (Serv_Conn'Access, "Documentos en la tabla: " & Integer'Image(PaqTabla.Tamano_Tabla) & " (llena)");
         end if;
      end if;
      String'Write (Serv_Conn'Access, "<BR>");
      Character'Write (Serv_Conn'Access, Ada.Characters.Latin_1.LF);
      AIO.Put_Line ("HE mandado la estadstica, Cierro la conexin con el cliente. ");
      TCP.Dispose (Serv_Conn);
   end Mandar_Estadistica;


   -- ************************************************************************************************************
   -- *                                        PROGRAMA PRINCIPAL                                                *
   -- ************************************************************************************************************

begin

   if Ada.Command_Line.Argument_Count /= 2 then
      raise Usage_Error;
   end if;

   -- Construyo la direccin ip
   Dir_IP := TCP.Build (Ada.Command_Line.Argument (1),
                           Integer'Value (Ada.Command_Line.Argument (2)));
   -- Escucho en esa direccin
   TCP.Listen_Connection (Dir_IP);

   loop
      -- Espero hasta recibir alguna peticin
      AIO.Put_Line ("ESPERO PETICIONES ... ");
      TCP.Wait_Connection (Dir_IP, Serv_Conn);
      Ada.Text_IO.Put_Line ("Conexin aceptada, recibiendo peticin....");

      Pet:= Extraer_Peticion;
      if ASU.To_String(Tipopet)="GET " then
         if (LLI.To_IP (ASU.To_String(Maquina))=LLI.To_IP(Ada.Command_Line.Argument(1)) and ASU.To_String(DirRel)/="/stats") then
            Mandar_Mi_Pagina;
         else
            if (ASU.To_String(DirRel)="/stats") then

               Mandar_Estadistica;
            else
               Num_Get:= Num_Get+1;
               Hacer_De_Proxy;
               Paqtabla.Visualizar_Tabla(Tabla, Indice);
            end if;
         end if;
      else
         Num_Put:= Num_Put+1;
         Hacer_Put;
      end if;

   end loop;

exception
   when Ada.IO_Exceptions.End_Error =>
      TCP.Dispose (Serv_Conn);
      Ada.Text_IO.Put ("Conexin cerrada por el cliente");
      Ada.Text_IO.New_Line;
   when Usage_Error =>
      Ada.Text_IO.Put_Line ("Two arguments needed: host_no and port");

end Servidor;
